const int FLEX_PIN = A0; // Pin connected to voltage divider output
const int FLEX_PIN_2 = A1;
const int FLEX_PIN_3 = A2;
const int FLEX_PIN_4 = A3;
// Measure the voltage at 5V and the actual resistance of your
// 47k resistor, and enter them below:
const float VCC = 4.98; // Measured voltage of Ardunio 5V line
const float R_DIV = 47500.0; // Measured resistance of 3.3k resistor

// Upload the code, then try to adjust these values to more
// accurately calculate bend degree.
const float STRAIGHT_RESISTANCE = 37300.0; // resistance when straight
const float BEND_RESISTANCE = 90000.0; // resistance at 90 deg

void setup() 
{
  Serial.begin(9600);
  pinMode(FLEX_PIN, INPUT);
  pinMode(FLEX_PIN_2, INPUT);
  pinMode(FLEX_PIN_3, INPUT);
  pinMode(FLEX_PIN_4, INPUT);
}

void loop() 
{
  // Read the ADC, and calculate voltage and resistance from it
  int flexADC = analogRead(FLEX_PIN);
  int flexADC_2 = analogRead(FLEX_PIN_2);
  int flexADC_3 = analogRead(FLEX_PIN_3);
  int flexADC_4 = analogRead(FLEX_PIN_4);
  float flexV = flexADC * VCC / 1023.0;
  float flexV_2 = flexADC_2 * VCC / 1023.0;
  float flexV_3 = flexADC_3 * VCC / 1023.0;
  float flexV_4 = flexADC_4 * VCC / 1023.0;
  float flexR = R_DIV * (VCC / flexV - 1.0);
  float flexR_2 = R_DIV * (VCC / flexV_2 - 1.0);
  float flexR_3 = R_DIV * (VCC / flexV_3 - 1.0);
  float flexR_4 = R_DIV * (VCC / flexV_4 - 1.0);
  Serial.println("Resistance (A0): " + String(flexR) + " ohms");
  Serial.println("Resistance (A1): " + String(flexR_2) + " ohms");
  Serial.println("Resistance (A2): " + String(flexR_3) + " ohms");
  Serial.println("Resistance (A3): " + String(flexR_4) + " ohms");

  // Use the calculated resistance to estimate the sensor's
  // bend angle:
  float angle = map(flexR, STRAIGHT_RESISTANCE, BEND_RESISTANCE,
                   0, 90.0);
  float angle_2 = map(flexR_2, STRAIGHT_RESISTANCE, BEND_RESISTANCE, 0, 90.0);
  float angle_3 = map(flexR_3, STRAIGHT_RESISTANCE, BEND_RESISTANCE, 0, 90.0);
  float angle_4 = map(flexR_4, STRAIGHT_RESISTANCE, BEND_RESISTANCE, 0, 90.0);
  Serial.println("Bend (A0): " + String(angle) + " degrees");
  Serial.println("Bend (A1): " + String(angle_2) + " degrees");
  Serial.println("Bend (A2): " + String(angle_3) + " degrees"); 
  Serial.println("Bend (A3): " + String(angle_4) + " degrees");
  Serial.println();

  delay(500);
}
